import java.util.*;
import java.sql.SQLOutput;

public class Field {
    private final int m;
    private final int n;
    public String[][] fieldShape;
    private Robber robber;
    private ArrayList<Police> polices = new ArrayList<Police>();


    public Field(int m, int n) {
        this.m = m;
        this.n = n;
        fieldShape = new String[m][n];
        for (int i = 0; i < m; i++)
            for (int j = 0; j < n; j++)
                fieldShape[i][j] = "-";
    }

    public void changeField() {
        for (int i = 0; i < m; i++)
            for (int j = 0; j < n; j++)
                fieldShape[i][j] = "-";

        fieldShape[robber.getX()][robber.getY()] = "D";
        boolean b = false;
        for (Police police : polices) {

            if (fieldShape[police.getX()][police.getY()].equals("D")) {
                b = true;
                fieldShape[police.getX()][police.getY()] = "*";

            }
            if (fieldShape[police.getPreviosX()][police.getPreviosY()].equals("D")) {
                b = true;

                fieldShape[police.getX()][police.getY()] = "*";

            }
            if (!fieldShape[police.getX()][police.getY()].equals("*"))
                fieldShape[police.getX()][police.getY()] = "P";
        }
        if (b == true) {
            showFieldShape();
            System.exit(0);
        }


    }

    public void setRobber(Robber robber) {
        this.robber = robber;
    }

    public Robber getRobber() {
        return robber;
    }

    public String[][] getCourt() {
        return fieldShape;
    }

    public ArrayList<Police> getPolices() {
        return polices;
    }

    public void randomPolicePlace(int policeNum) {
        Random random = new Random();

        for (int i = 0; i < policeNum; i++) {
            int x = random.nextInt(m);
            int y = random.nextInt(n);
            boolean bl = true;
            if (polices.size() != 0) {
                for (Police police : polices) {
                    if (police.getX() == x && police.getY() == y) {
                        i--;
                        bl = false;
                        break;
                    }
                }
            }
            if (bl == true) {
                fieldShape[x][y] = "P";
                Police p = new Police(x, y);
                polices.add(p);
            }


        }

    }

    public void randomRobberPlce() {
        Random random = new Random();
        while (true) {
            int x = random.nextInt(m);
            int y = random.nextInt(n);
            boolean b = true;
            for (Police police : polices) {
                if (police.getX() == x && police.getY() == y)
                    b = false;
            }
            if (b == true) {
                robber = new Robber(x, y);
                fieldShape[x][y] = "D";
                break;
            }
        }
    }

    public void showFieldShape() {
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++)
                System.out.print(fieldShape[i][j] + " | ");
            System.out.println();
        }

    }


}

